#include <entry.h>
#include "../treeprinter/treeprinter.h"
#include <iostream>

using namespace std;

/**
 * This is an example of how to construct a tree manually
 * for testing purposes.
 */
int main()
{
  /** Construct a root entry, this should be empty */
  Entry *root = new Entry;

  Entry *file = new Entry;
  file->section = Entry::SOURCE_SEC; // Set entry type
  file->name = "MT-3.v";            // Set entry name
  file->fileName = "MT-3.v";        // File this entry was found in
  file->bodyLine = file->startLine = 1; // Line # of entry
  file->parent = root;               // Set parent
  root->addSubEntry(file);           // Add to (the same) parent

  Entry *module = new Entry;
  module->section = Entry::MODULE_SEC;
  module->name = "MT-3";
  module->fileName = "MT-3.v";        // File this entry was found in
  module->bodyLine = module->startLine = 3; // Line # of entry
  module->doc = "This is a fancy module. Wanna touch it? eh? Wanna touch my module?";   // Multi-line documenting comment
  module->docLine = 2;                 // Line # of long comment
  module->parent = root;               // Set parent
  root->addSubEntry(module);           // Add to (the same) parent

  TreePrinter tp(true);
  tp.print(cout, root);
}
