#include <entry.h>
#include "../treeprinter/treeprinter.h"
#include <iostream>

using namespace std;

/**
 * Module test 4.
 * Used to verify that the Tree printer writes out every wire that the AST contains.
 */
int main()
{
  /** Construct a root entry, this should be empty */
  Entry *root = new Entry;
  //  root->extends = 0; tobbe: should be

  Entry *file = new Entry;
  file->section = Entry::SOURCE_SEC; // Set entry type
  file->name = "smurf.v";            // Set entry name
  file->fileName = "smurf.v";        // File this entry was found in
  file->bodyLine = file->startLine = 1; // Line # of entry
  file->parent = root;               // Set parent
  root->addSubEntry(file);           // Add to (the same) parent



  Entry *module0 = new Entry;
  module0->section = Entry::MODULE_SEC;
  module0->name = "mod0";
  module0->fileName = "some_file.v";        // File this entry was found in
  module0->bodyLine = module0->startLine = 3; // Line # of entry
  module0->parent = root;               // Set parent
  root->addSubEntry(module0);           // Add to (the same) parent


  Entry *module = new Entry;
  module->section = Entry::MODULE_SEC;
  module->name = "mod1";
  module->fileName = "weee.v";        // File this entry was found in
  module->bodyLine = module->startLine = 3; // Line # of entry
  module->parent = module0;               // Set parent
  module0->addSubEntry(module);           // Add to (the same) parent

  Entry *node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "mod1_w1";
  node->fileName = "smurf.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "mod1_w2";
  node->fileName = "gammelsmurfen.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "mod1_w3";
  node->fileName = "gammelsmurfen.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent



  module = new Entry;
  module->section = Entry::MODULE_SEC;
  module->name = "mod2";
  module->fileName = "weee.v";        // File this entry was found in
  module->bodyLine = module->startLine = 3; // Line # of entry
  module->parent = module0;               // Set parent
  module0->addSubEntry(module);           // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "mod2_w1";
  node->fileName = "gammelsmurfen.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "mod2_w2";
  node->fileName = "gammelsmurfen.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "mod2_w3";
  node->fileName = "gammelsmurfen.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent



  module = new Entry;
  module->section = Entry::MODULE_SEC;
  module->name = "mod3";
  module->fileName = "yaaarrrr.v";        // File this entry was found in
  module->bodyLine = module->startLine = 3; // Line # of entry
  module->parent = module0;               // Set parent
  module0->addSubEntry(module);           // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "mod3_w1";
  node->fileName = "gammelsmurfen.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "mod3_w2";
  node->fileName = "gammelsmurfen.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  node->name = "mod3_w3";
  node->fileName = "gammelsmurfen.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent
  


  TreePrinter tp(false, 7);
  tp.print(cout, root);
  //  cout << TreePrinter(root);
}
