#include <entry.h>
#include "../treeprinter/treeprinter.h"
#include <iostream>

using namespace std;

/**
 * This is an example of how to construct a tree manually
 * for testing purposes.
 */
int main()
{
  /** Construct a root entry, this should be empty */
  Entry *root = new Entry;

  Entry *file = new Entry;
  file->section = Entry::SOURCE_SEC; // Set entry type
  file->name = "MT-3.v";            // Set entry name
  file->fileName = "MT-3.v";        // File this entry was found in
  file->bodyLine = file->startLine = 1; // Line # of entry
  file->parent = root;               // Set parent
  root->addSubEntry(file);           // Add to (the same) parent

  Entry *module = new Entry;
  module->section = Entry::MODULE_SEC;
  module->name = "MT-3";
  module->fileName = "MT-3.v";        // File this entry was found in
  module->bodyLine = module->startLine = 3; // Line # of entry
  module->doc = "This is a fancy module. Wanna touch it? eh? Wanna touch my module?";   // Multi-line documenting comment
  module->docLine = 2;                 // Line # of long comment
  module->parent = root;               // Set parent
  root->addSubEntry(module);           // Add to (the same) parent

  Entry *node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  //node->type = "input";              // This is a module input signal
  // node->protection = Public;         // Public is used for input, output & inout.
  node->name = "wb_we_i";
  node->fileName = "smurf.v";        // File this entry was found in
  node->bodyLine = node->startLine = 7; // Line # of entry
  // node->brief = "This is one of my many inputs. The only one you'll ever see."; // One line documenting comment
  //node->briefLine = 7;               // Line # of brief comment
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  //  node->type = "output";
  //node->protection = Public;
  node->name = "wb_d_o";
  node->args = "[31:0]";             // Set range
  node->fileName = "smurf.v";        // File this entry was found in
  node->bodyLine = node->startLine = 8; // Line # of entry
  //node->brief = "And this is my output";
  //node->briefLine = 8;
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent

  node = new Entry;
  node->section = Entry::VARIABLE_SEC;
  //node->type = "wire";
  // node->protection = Private;
  node->name = "sladden";
  //node->args = "";
  node->fileName = "smurf.v";        // File this entry was found in
  node->bodyLine = node->startLine = 12; // Line # of entry
  //  node->brief = "This is my big and fancy wire.";
  // node->briefLine = 12;
  node->parent = module;             // Set parent
  module->addSubEntry(node);         // Add to (the same) parent


  TreePrinter tp(true);
  tp.print(cout, root);
}
