#include <pre.h>
#include <bufstr.h>
#include <doxygen.h>

#include <qfile.h>
#include <qfileinfo.h>

#include <iostream>

using namespace std;

int main(int argc, char *argv[])
{
  if (argc < 2) {
    cerr << "Usage: " << argv[0] << " <filename>*" << endl;
    return 1;
  }

  initDoxygen();
  Doxygen::inputNameDict = new FileNameDict(10007);
  readConfiguration(0, 0);

  for (int i = 1; i < argc; i++) {
    QCString fileName = argv[i];

    QFileInfo fi(fileName);
    BufStr preBuf(fi.size()+4096);
    BufStr *bufPtr = &preBuf;

    cout << "Reading " << fileName << "..." << endl;

    preprocessFile(fileName, *bufPtr);

    bufPtr->addChar('\n');
    bufPtr->addChar('\0');

    cout << preBuf.data() << endl;
  }
  
  return 0;
}
