module MUX2 (input SEL, A, B, output F);
  input SEL, A, B;
  output F;
  INV G1 (SEL, SELB);
  AOI G2 (SELB, A, SEL, B, FB);
  INV G3 (.A(FB), .F(F));
endmodule

module full_addr( a, b, c_in, c_out, sum );
input a, b, c_in;
output sum, c_out;

wire a1, a2, a3, a4;
wire c1, c2, c3, c4;

  assign a1 = (~a) & (~b) &   c_in;
  assign a2 = (~a) &   b  & (~c_in);
  assign a3 =   a  & (~b) & (~c_in);
  assign a4 =   a  &   b  &   c_in;
  assign sum = a1 | a2 | a3 | a4;

  assign c1 = (~a) &   b  &   c_in;
  assign c2 =   a  & (~b) &   c_in;
  assign c3 =   a  &   b  & (~c_in);
  assign c4 =   a  &   b  &   c_in;
  assign c_out = c1 | c2 | c3 | c4;

endmodule

module mult( A, B, rslt );
input  [ 3:0] A, B;
output [  7:0] rslt;

wire a00, a01, a02, a03;

wire b00, b01, b02, b03;

wire r00, r01, r02, r03, r04, r05, r06, r07;

wire c00, c01, c02, c03, c04, c05, c06, c07;
wire c08, c09, c10, c11;

  assign a00 = A[ 0];
  assign a01 = A[ 1];
  assign a02 = A[ 2];
  assign a03 = A[ 3];

  assign b00 = B[ 0];
  assign b01 = B[ 1];
  assign b02 = B[ 2];
  assign b03 = B[ 3];

  assign rslt[ 0] = r00;
  assign rslt[ 1] = r01;
  assign rslt[ 2] = r02;
  assign rslt[ 3] = r03;
  assign rslt[ 4] = r04;
  assign rslt[ 5] = r05;
  assign rslt[ 6] = r06;
  assign rslt[ 7] = r07;

  assign r00 = a00 & b00;
  full_addr fa000 (a01 & b00, a00 & b01, 1'b0, c00, s00);
  full_addr fa001 (a02 & b00, a01 & b01, 1'b0, c01, s01);
  full_addr fa002 (a03 & b00, a02 & b01, 1'b0, c02, s02);
  assign r01 = s00;

  full_addr fa003 (s01 , a00 & b02, c00, c03, s03);
  assign r02 = s03;
  full_addr fa004 (s02 , a01 & b02, c01, c04, s04);
  full_addr fa005 (a03 & b01, a02 & b02, c02, c05, s05);

  full_addr fa006 (s04 , a00 & b03, c03, c06, s06);
  assign r03 = s06;
  full_addr fa007 (s05 , a01 & b03, c04, c07, s07);
  full_addr fa008 (a03 & b02, a02 & b03, c05, c08, s08);

  full_addr fa009 (s07 , 1'b0, c06, c09, s09);
  assign r04 = s09;
  full_addr fa010 (s08 , c09, c07, c10, s10);
  assign r05 = s10;
  full_addr fa011 (a03 & b03, c10, c08, c11, s11);

  assign r06 = s11;
  assign r07 = c11;
endmodule